## dde-tray-loader 0.0.10

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

CMAKE_MINIMUM_REQUIRED(VERSION 3.16)

set(DTL_VERSION "0.0.1" CACHE STRING "Define project version")
project(dde-tray-loader
    VERSION "${DTL_VERSION}"
    DESCRIPTION "dde-tray-loader"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-tray-loader"
    LANGUAGES CXX C
)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(DTL_BUILD_WITH_QT6 ON CACHE BOOL "Build dde-tray-loader with Qt6")

if (DTL_BUILD_WITH_QT6)
    set(QT_VERSION_MAJOR 6)
    set(DTK_VERSION_MAJOR 6)
else()
    set(QT_VERSION_MAJOR 5)
    set(DTK_VERSION_MAJOR "")
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

add_subdirectory(plugins)
add_subdirectory(src)

configure_file(dde-dock.pc.in dde-dock.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dde-dock.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

## dev files
file(GLOB INTERFACES "interfaces/*.h"
                     "src/tray-wayland-intergration/plugin.h")
install(FILES ${INTERFACES}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-dock)

## protocol
file(GLOB PROTOCOL "src/protocol/*.xml")
install(FILES ${PROTOCOL}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-tray-loader/protocol)

configure_file(dde-tray-loader.pc.in ${CMAKE_BINARY_DIR}/dde-tray-loader.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dde-tray-loader.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/DdeTrayLoader/DdeTrayLoaderConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DdeTrayLoaderConfig.cmake
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeTrayLoaderConfig.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeTrayLoader)

configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/DdeDock/DdeDockConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DdeDockConfig.cmake
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeDockConfig.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeDock)

configure_file(environments.h.in environments.h @ONLY)

=== plugins/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0


# FIXME: copy from dde-network-core need to fix dde-network-core and remove those code
find_package(PkgConfig REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)
include_directories(${LibNM_INCLUDE_DIRS})

pkg_check_modules(Gio REQUIRED gio-2.0)
include_directories(${Gio_INCLUDE_DIRS})

pkg_search_module(GLIB REQUIRED glib-2.0)
include_directories(${GLIB_INCLUDE_DIRS})
link_directories(${GLIB_LIBRARY_DIRS})

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

# test networkmanagetqt
try_compile(DEEPIN_NMQT_TEST
              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
            SOURCES
              ${CMAKE_CURRENT_SOURCE_DIR}/try-compile/networkmanagerqt.cc
            LINK_LIBRARIES
              ${KF5_QT_LIBRARIES}
              Qt5::Core
              Qt5::DBus
              Qt5::Network
            CMAKE_FLAGS
              "-DINCLUDE_DIRECTORIES=${KF5_QT_INCLUDE_DIRS}\;${GLIB_INCLUDE_DIRS}\;${LibNM_INCLUDE_DIRS}"
            OUTPUT_VARIABLE
              result
)
message(STATUS DEEPIN_NMQT_TEST ": ${DEEPIN_NMQT_TEST}")


add_subdirectory(application-tray)
add_subdirectory(dde-dock)
if (DEEPIN_NMQT_TEST)
    add_subdirectory(dde-network-core)
    add_subdirectory(dde-network-display-ui)
endif(DEEPIN_NMQT_TEST)

=== plugins/application-tray/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(PLUGIN_NAME "application-tray")

project(${PLUGIN_NAME})

find_package(PkgConfig REQUIRED)
find_package(dbusmenu-qt5 REQUIRED)
find_package(Qt5 REQUIRED Core Gui Widgets DBus)
find_package(Dtk REQUIRED Core Gui Widget)

pkg_check_modules(X11 REQUIRED IMPORTED_TARGET x11 xcb xcb-image xcb-composite xcb-xfixes xcb-util xcb-shape xtst xcb-xtest xcb-res xcb-ewmh)

file (GLOB TRAY_SOURCES *.cpp *.h api/types/*.cpp)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.dde.TrayManager1.xml
    PROPERTIES  INCLUDE api/types/traylist.h
                CLASSNAME TrayManager
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.kde.StatusNotifierItem.xml
    PROPERTIES  INCLUDE api/types/dbusimagelist.h
                INCLUDE api/types/dbustooltip.h
                CLASSNAME StatusNotifierItem
)

qt5_add_dbus_interfaces(
    DBUS_INTERFACES
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.dde.TrayManager1.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.kde.StatusNotifierItem.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.kde.StatusNotifierWatcher.xml
)

add_library(${PLUGIN_NAME} SHARED
    ${DBUS_INTERFACES}
    ${TRAY_SOURCES}
    application-tray.qrc
)

target_compile_definitions(${PLUGIN_NAME} PRIVATE "QT_PLUGIN")

target_link_libraries(${PLUGIN_NAME}
    PRIVATE
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Dtk::Core
        Dtk::Gui
        Dtk::Widget
        PkgConfig::X11
        dbusmenu-qt5
        dockpluginmanager-interface
)

target_include_directories(${PLUGIN_NAME} PUBLIC
    "${CMAKE_SOURCE_DIR}/interfaces/"
    "${CMAKE_SOURCE_DIR}/src/tray-wayland-integration/"
)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins/dde-dock)
# 设置执行 make install 时哪个目标应该被 install 到哪个位置
install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)

=== plugins/dde-dock/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

add_subdirectory("airplane-mode")
add_subdirectory("bluetooth")
add_subdirectory("brightness")
add_subdirectory("datetime")
add_subdirectory("dnd-mode")
add_subdirectory("eye-comfort-mode")
add_subdirectory("keyboard-layout")
add_subdirectory("media")
add_subdirectory("onboard")
add_subdirectory("power")
add_subdirectory("shutdown")
add_subdirectory("sound")
add_subdirectory("notification")

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif ()

## qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES}
    DESTINATION share/dde-dock/translations)

=== src/tray-wayland-integration/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

find_package(Qt5 REQUIRED COMPONENTS Gui WaylandClient XkbCommonSupport)
find_package(Dtk REQUIRED COMPONENTS Gui Widget)

find_package(ECM REQUIRED MO_MODULE)
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${ECM_MODULE_PATH}")
find_package(QtWaylandScanner)
find_package(PkgConfig REQUIRED)

pkg_check_modules(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

include(KDEInstallDirs)

add_library(dockpluginmanager-interface SHARED
    plugin.h
    plugin.cpp
)

target_include_directories(dockpluginmanager-interface PUBLIC
    "interfaces/"
)

target_link_libraries(dockpluginmanager-interface
PUBLIC
    Qt5::Gui
    Qt5::Widgets
    Dtk::Widget
    PkgConfig::XKBCOMMON
)

add_library(dockpluginmanager SHARED
    pluginmanager_p.h
    pluginmanager.cpp
    pluginmanagerintegration_p.h
    pluginmanagerintegration.cpp
    pluginsurface_p.h
    pluginsurface.cpp
    main.cpp
)

ecm_add_qtwayland_client_protocol(dockpluginmanager
PROTOCOL
    ${CMAKE_CURRENT_SOURCE_DIR}/../protocol/plugin-manager-v1.xml
BASENAME
    plugin-manager-v1
)

target_link_libraries(dockpluginmanager
PUBLIC
    dockpluginmanager-interface
PRIVATE
    PkgConfig::WaylandClient
    PkgConfig::XKBCOMMON
    Qt5::WaylandClientPrivate
    Qt5::XkbCommonSupportPrivate
)

set_target_properties(dockpluginmanager PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins/wayland-shell-integration"
    OUTPUT_NAME plugin-shell
)

set_target_properties(dockpluginmanager-interface PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins/"
    OUTPUT_NAME dde-trayplugin-interface
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
)

# Do not install .so development library for we don't want others to link to it.
install(TARGETS dockpluginmanager-interface DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS dockpluginmanager DESTINATION ${KDE_INSTALL_QTPLUGINDIR}/wayland-shell-integration)

=== plugins/dde-dock/bluetooth/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "bluetooth")

project(${PLUGIN_NAME})

# Sources files
file(GLOB_RECURSE SRCS
    "*.h"
    "*.cpp"
    "../widgets/*.h"
    "../widgets/*.cpp"
    "../util/imageutil.h"
    "../util/imageutil.cpp"
    "../util/statebutton.h"
    "../util/statebutton.cpp"
    "../util/horizontalseparator.h"
    "../util/horizontalseparator.cpp"
    "../common/*.h"
    "../common/*.cpp"
)

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(XCB_EWMH REQUIRED xcb-ewmh x11 xcursor)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/bluetooth.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS}
  ${DFrameworkDBus_INCLUDE_DIRS}
  ${QGSettings_INCLUDE_DIRS}
  ../../../interfaces
  ../common
  ../util
  ../widgets
  componments)

target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${XCB_EWMH_LIBRARIES}
  ${DtkWidget_LIBRARIES}
  ${DFrameworkDBus_LIBRARIES}
  ${QGSettings_LIBRARIES}
  ${Qt5DBus_LIBRARIES}
  ${Qt5Widgets_LIBRARIES}
  ${Qt5Svg_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/system-trays)
install(FILES "resources/bluetooth.svg" DESTINATION share/dde-dock/icons/dcc-setting)

=== plugins/dde-dock/brightness/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "brightness")

project(${PLUGIN_NAME})

# Sources files
file(GLOB_RECURSE SRCS
    "*.h"
    "*.cpp"
    "../widgets/*.h"
    "../widgets/*.cpp"
    "../common/*.h"
    "../common/*.cpp"
    "../util/roundscrollarea.h"
    "../util/roundscrollarea.cpp"
)

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(Qt5Concurrent REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/brightness.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ../../../interfaces
    ../widgets
    ../util
    ../common
)
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)
install(FILES "resources/dde-brightness.svg" DESTINATION share/dde-dock/icons/dcc-setting)

=== plugins/dde-dock/datetime/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "datetime")

project(${PLUGIN_NAME})

# Sources files
file(GLOB_RECURSE SRCS "*.h" "*.cpp" "../widgets/*.h" "../widgets/*.cpp" "../common/*.h" "../common/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/datetime.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC
  ${DtkWidget_INCLUDE_DIRS}
  ${DFrameworkDBus_INCLUDE_DIRS}
  ${QGSettings_INCLUDE_DIRS}
  ../../../interfaces
  ../common
  ../widgets
  ../util
  calendar
  )
target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${Qt5DBus_LIBRARIES}
  ${DtkWidget_LIBRARIES}
  ${Qt5Widgets_LIBRARIES}
  ${Qt5Svg_LIBRARIES}
  ${DFrameworkDBus_LIBRARIES}
  ${QGSettings_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)
install(FILES "resources/datetime.svg" DESTINATION share/dde-dock/icons/dcc-setting)

=== plugins/dde-dock/dnd-mode/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "dnd-mode")

project(${PLUGIN_NAME})

# Sources files
file(GLOB_RECURSE SRCS
    "*.h"
    "*.cpp"
    "../widgets/*.h"
    "../widgets/*.cpp"
    "../common/*.h"
    "../common/*.cpp"
)

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/dnd_mode.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ../../../interfaces
    ../widgets
    ../util
    ../common
)
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)
install(FILES "resources/dnd-mode.svg" DESTINATION share/dde-dock/icons/dcc-setting)

=== plugins/dde-dock/eye-comfort-mode/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "eye-comfort-mode")

project(${PLUGIN_NAME})

# Sources files
file(GLOB_RECURSE SRCS
    "*.h"
    "*.cpp"
    "../widgets/*.h"
    "../widgets/*.cpp"
    "../common/*.h"
    "../common/*.cpp"
)

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/eye-comfort-mode.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ../../../interfaces
    ../widgets
    ../common
    ../util
)
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)
install(FILES "resources/eye-comfort-mode.svg" DESTINATION share/dde-dock/icons/dcc-setting)

=== plugins/dde-dock/media/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "media")

project(${PLUGIN_NAME})

# Sources files
file(GLOB_RECURSE SRCS
    "*.h"
    "*.cpp"
    "../widgets/*.h"
    "../widgets/*.cpp"
    "../common/*.h"
    "../common/*.cpp"
)

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/media.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ../../../interfaces
    ../widgets
    ../common
)
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)

=== plugins/dde-dock/notification/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "notification")
find_package(Qt5 REQUIRED COMPONENTS DBus)
find_package(Dtk REQUIRED COMPONENTS Widget Gui)

add_library(${PLUGIN_NAME} SHARED
    notification.h
    notification.cpp
    notificationplugin.h
    notificationplugin.cpp
    notification.qrc
    ../widgets/tipswidget.h
    ../widgets/tipswidget.cpp
)
target_compile_definitions(${PLUGIN_NAME} PRIVATE QT_PLUGIN)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../dde-dock)

target_include_directories(${PLUGIN_NAME} PRIVATE
   "../../../interfaces"
   "../widgets"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    Dtk::Widget
    Qt5::DBus
    # Dtk6::Widget
    Dtk::Gui
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)
install(FILES "icons/notification.svg" DESTINATION share/dde-dock/icons/dcc-setting)

=== debian/changelog ===
dde-tray-loader (0.0.10) unstable; urgency=medium

  * fix: the text color is incorrect(Issue: 10106)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 13 Aug 2024 20:45:53 +0800

dde-tray-loader (0.0.9) unstable; urgency=medium

  * fix: Fixed the right-click display settings cannot jump to the control center (#136)(Issue: 10336)
  * fix: Remove the Airplane Mode setting option from the Control Center (#137)(Issue: 10335)
  * fix: tooltip content cannot update(Issue: 10361)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 13 Aug 2024 16:00:51 +0800

dde-tray-loader (0.0.8) unstable; urgency=medium

  * bump version to 0.0.8

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 12 Aug 2024 17:30:11 +0800

dde-tray-loader (0.0.7) unstable; urgency=medium

  * fix:  clicking quickItem plugin with the left mouse button donot work(Influence: left mouse clicking quickItem)
  * fix: The DBus service name has been modified(Issue: 10018)
  * fix: When modifying the VPN, the wireless network icon does not display(Issue: 10195)
  * fix: Modify network non automatic reconnection issue(Issue: 10184)
  * fix: Translation issue not installed when modifying user acquisition error(Issue: 10018)
  * fix: quickpanel show empty if click tray's item(Issue: 10229)
  * chore: removing print too many logs(Influence: none)
  * fix: app crashed cannot generate coredump file(Influence: app crashed has coredump file)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 08 Aug 2024 15:08:41 +0800

dde-tray-loader (0.0.6) unstable; urgency=medium

  * fix: adjust tooltip display(Issue: 10043)
  * fix: Cursor instantly move to left side(Issue: 9987)
  * fix: date text color does not change with theme(Issue: 10104)
  * fix: bluetooth devices list width(Issue: 9981)
  * fix: Menu display incomplete(Issue: 9721 9729)
  * fix: Popup position cannot be refreshed with dock(Issue: 10096)
  * fix: Error in modifying IP address display(Issue: 10073)
  * fix: update dde-dock plugins translate(Issue: 10123 10012)
  * fix: Modify the issue of dock plugin crashing when double clicking(Issue: 10118 10067)
  * fix: at high PixelRatio, the datetime display is too large
  * fix: subMenu can't show
  * fix: The margin issue of Tooltip(Issue: 10005 9997)

 -- Zhang kun <zhangkun2@uniontech.com>  Tue, 06 Aug 2024 15:41:06 +0800

dde-tray-loader (0.0.5) unstable; urgency=medium

  * fix: onboard plugin is not installed(Issue: 9820)
  * fix: ToolTip is positioned to the left(Issue: 9953)
  * fix: update taskbar plug-in translation (#88)(Issue: 9893)
  * description: Power switching mode adds performance mode switching(Issue: 9893)
  * fix: Fixed dnd-mode settings cannot jump to the Control Center(Issue: 9988)
  * feat: request isActive state for quickpanel(Issue: 10020)
  * fix: right button also emits clicked for quickpanel(Issue: 9960)
  * chore: refactor the dateTime plugin display code (#93)(Influence: datetime plugin display)
  * fix: dateTime panel popup date and 12hour format display does not match the settings (#96)(Influence: datetime plugin display)
  * fix: removing jump to dcc's airplane mode(Issue: 9990)(Influence: bluetooth can not jump to dcc's airplane mode)
  * fix: Fixed  the power performance mode initialization dnot get init value (#99)(Issue: 10019)

 -- zyz <zhaoyingzhen@uniontech.com>  Wed, 31 Jul 2024 14:07:12 +0800

dde-tray-loader (0.0.4) unstable; urgency=medium

  * fix: network view size cannot respond to content changes in a timely manner(Issue: 9881)(Influence: network view size)
  * fix: Update translation file path(Issue: 9956)
  * fix: datetime plugin set 24-hour format do not work(Issue: 9717, 9857)(Influence: datetime plugin display)

 -- zyz <zhaoyingzhen@uniontech.com>  Thu, 25 Jul 2024 16:23:30 +0800

dde-tray-loader (0.0.3) unstable; urgency=medium

  * feat: plugin item can set content margin (#65)(Influence: plugin item display)
  * chore: update the eye comfort mode icon(Issue: 9875)
  * fix: EyeComfortMode plugin can switch theme type (#69)(Issue: 9691)(Influence: can switch themme type)
  * fix: Fixed the issue that setting custom time format in taskbar does not take effect(Issue: 9724)
  * fix: Added trayplugin-loader translation(Issue: 9754, 9685)
  * fix: Modifying proxy icon does not display issue(Issue: 9888)
  * fix: applicatin-tray coredump while open wechat and wework(issue: 9918)
  * fix: Hide Airplane mode settings in popup applet(Issue: 9884)

 -- zyz <zhaoyingzhen@uniontech.com>  Wed, 24 Jul 2024 14:31:44 +0800

dde-tray-loader (0.0.2) unstable; urgency=medium

  * fix: datetime plugin in DCC dosn't have icon
  * fix: Responding to proxy change signals (#58)

 -- Yingzhen zhao <zhaoyingzhen@uniontech.com>  Fri, 19 Jul 2024 17:32:20 +0800

dde-tray-loader (0.0.1) unstable; urgency=medium

  * chore: add dde-dock.pc
  * FIX 1070 errors
  * fix: compile errors
  * fix: solve the problem of failed compilation
  * chore: add plugins and loader
  * chore: add the README

 -- Wang Fei <wangfei@deepin.org>  Wed, 26 Jun 2024 11:33:24 +0800

dde-tray-loader (0.0.0) unstable; urgency=medium

  * 0.0.0

 -- Wang Fei <wangfei@deepin.org>  Tue, 25 Jun 2024 16:53:15 +0800

=== debian/control ===
Source: dde-tray-loader
Section: unknown
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper-compat ( =12),
 pkg-config,
 cmake,
 extra-cmake-modules,
 qt5-qmake,
 libxcb-image0-dev,
 libxcb-composite0-dev,
 libxcb-ewmh-dev,
 libxtst-dev,
 libxcb-xtest0-dev,
 libxcb-res0-dev,
 libxcb-util-dev,
 qttools5-dev-tools,
 qtbase5-private-dev,
 libxcb-icccm4-dev,
 libqt5x11extras5-dev,
 libxcb-damage0-dev,
 libqt5svg5-dev,
 libdtkwidget-dev (>=5.4.19),
 libdtkcore-dev (>=5.4.14),
 libdtkcore5-bin (>=5.4.14),
 libdtkgui-dev (>=5.4.13),
 libdframeworkdbus-dev (>=6.0.1),
 libgsettings-qt-dev,
 libdbusmenu-qt5-dev,
 libgtest-dev,
 libgmock-dev,
 qttools5-dev,
 libxcursor-dev,
 dde-api-dev (>>5.6.3),
 libkf5networkmanagerqt-dev (>=5.103.0-1deepin2),
 libkf5wayland-dev,
 libqt5waylandclient5-dev,
 qtwayland5-dev-tools,
 qtwayland5-private-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org/

Package: dde-tray-loader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 deepin-desktop-schemas (>=5.9.14),
 libdtkwidget5 (>=5.4.19),
 libdtkcore5 (>=5.4.14),
 libdtkgui5 (>=5.4.13),
 libdframeworkdbus2 (>=6.0.1),
 dde-qt5xcb-plugin (>=5.0.25),
 dde-daemon (>=5.13.12),
 startdde (>=5.8.9),
 lastore-daemon (>=5.2.9),
 qtxdg-dev-tools,
 deepin-service-plugin-network,
 dde-api-dbus-proxy-v1 (>=1.0.10)
Conflicts:
 dde-dock,
 dde-dock-onboard-plugin
Replaces:
 dde-dock,
 dde-dock-onboard-plugin
Description: deepin desktop-environment - the plugins of tray for dde-dock
 Tray plugins module

Package: dde-tray-loader-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 dde-dock-dev
Replaces:
 dde-dock-dev
Provides:
 dde-dock-dev (=6.1.0)
Description: deepin desktop-environment - tray plugins module development files
 Tray plugins module development files of deepin desktop-environment

Package: deepin-service-plugin-network
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},curl
Description: the plugin of network service for deepin-service-manager
 deepin-service-plugin-network module

## dde-tray-loader 1.0.5

=== debian/changelog ===
dde-tray-loader (1.0.5) unstable; urgency=medium

  * feat: Allow plugins sending close quick panel requests
  * fix: plugin popup/tooltip pos not correct

 -- Wu Haotian <wuhaotian@uniontech.com>  Fri, 01 Nov 2024 10:10:08 +0800

dde-tray-loader (1.0.4) unstable; urgency=medium

  * fix: Datetime plugin display problem

 -- xionglinlin <xionglinlin@uniontech.com>  Thu, 24 Oct 2024 10:23:21 +0800

dde-tray-loader (1.0.3) unstable; urgency=medium

  * fix: right-click menu icon adapts to dark theme
  * fix: no "Open Calendar" button in non-Chinese environments
  * fix: wrong time format

 -- xionglinlin <xionglinlin@uniontech.com>  Wed, 16 Oct 2024 16:46:24 +0800

dde-tray-loader (1.0.2) unstable; urgency=medium

  * fix: the calendar plugin is abnormal when the calendar app does not exist

 -- xionglinlin <xionglinlin@uniontech.com>  Wed, 25 Sep 2024 16:41:33 +0800

dde-tray-loader (1.0.1) unstable; urgency=medium

  * fix: Music icon is too small in quick panel on High scale ratio screen
    fix: tooltip style is inconsistent

 -- Yutao Meng <mengyutao@deepin.org>  Wed, 04 Sep 2024 17:43:39 +0800

dde-tray-loader (1.0.0) unstable; urgency=medium

  * Fix incomplete display of Bluetooth plug-in prompts
    (linuxdeepin/developer-center#10479)
  * Fix crash on TreeLand
  * Update translation from Transifex

 -- Wang Zichong <wangzichong@deepin.org>  Mon, 02 Sep 2024 16:22:00 +0800

dde-tray-loader (0.0.12) unstable; urgency=medium

  * fix: Updated ordering of performance modes for power supplies (#151)(Issue: 10112)
  * fix: ap label font color not incorrect(Issue: 10460)
  * fix: Synchronized network translation(Issue: 10066)
  * fix: sni protocol item has no icon (#154)(Issue: 10144)
  * fix: plugin item menu does not have the option 'remove from dock'(Issue: 10359)
  * fix: tooltip margin and tooltip disappears abnormally(Issue: 10478)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 29 Aug 2024 10:14:21 +0800

dde-tray-loader (0.0.11) unstable; urgency=medium

  * fix: adding tray icon blocks app launch(Issue: 10439)
  * feat: add destroy protocol(Issue: 10121)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 21 Aug 2024 17:02:04 +0800
